#!/usr/bin/python

import argparse
import os
import sys
import yaml
from operator import itemgetter, attrgetter
from itertools import groupby
import re

def crunch(doc,debug):
    #for i in doc :
    #    print i['breaks']
    filterdoc = filter(lambda x: x, doc)
    l = sorted(filterdoc, key=lambda d : d['breaks'], reverse=True)
    #sorted by breaks
    for d in l :
        if d is not None and 'cluster' in d :
            sc = ''
            if 'subclusterof' in d :
                sc = d['subclusterof']
            print '%s | %s | %s | %s | %s ' % (
                    d['cluster'],sc,d['target'],d['equivs'],d['breaks'])

def main():
    parser = argparse.ArgumentParser(description='challenged data cruncing')
    parser.add_argument('-v', '--verbose')
    parser.add_argument('-d', '--debug', action='store_true', default=False)
    parser.add_argument('data', type=str, nargs=1, help="challenged output")
    args = parser.parse_args()

    doc = yaml.load_all(file(args.data[0],'r'))
    data = crunch(doc,args.debug)

if __name__ == '__main__':
    main()
