#!/usr/bin/python

import argparse
import os
import sys
import yaml
from operator import itemgetter, attrgetter
from subprocess import Popen, PIPE
from itertools import groupby
import re

DISTCHECK="/usr/local/bin/debcheck"
OUTDATED="/usr/local/bin/outdated"

def runtools(dist,out,packages) :
    timestamp = packages.split('/')[1]

    cmd = [DISTCHECK, "--progress", '-f', '-e', packages]
    #print " ".join(cmd)
    p = Popen(cmd, stdout=PIPE)
    output = p.communicate()[0]
    o = open("%s-%s-distcheck.yaml" % (timestamp,dist),'w')
    o.write(output)
    o.close()
    data = yaml.load(output)
    broken_debcheck = data['broken-packages']
    total_packages = data['total-packages']

    cmd = [OUTDATED, "--progress", '-f', '-e', packages]
    #print " ".join(cmd)
    p = Popen(cmd, stdout=PIPE)
    output = p.communicate()[0]
    o = open("%s-%s-outdated.yaml" % (timestamp,dist),'w')
    o.write(output)
    o.close()
    data = yaml.load(output)
    broken_outdated = data['broken-packages']

    print >>out, "%s %s %s %s %s" %(timestamp,dist,total_packages,broken_debcheck,broken_outdated)

def main():
    parser = argparse.ArgumentParser(description='future data cruncing')
    parser.add_argument('-v', '--verbose')
    parser.add_argument('-d', '--debug', action='store_true', default=False)
    parser.add_argument('sample', type=str, nargs=1, help="sample")
    args = parser.parse_args()

    sample = args.sample[0]

    dists = ["wheezy","unstable"]
    out = open(sample,'w')
    for root, dirs, files in os.walk('archive'):
        for dist in dists : 
            if dist in dirs :
                packages = os.path.join(root,"%s/main/binary-amd64" % dist,"Packages.bz2")
                if os.path.exists(packages) and os.path.getsize(packages) > 0 :
                    runtools(dist,out,packages)
    out.close()

if __name__ == '__main__':
    main()

